> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/infra-controller/llms.txt.
> For full documentation content, see https://docs.nvidia.com/infra-controller/llms-full.txt.

# Create IP Block

POST https://carbide-rest-api.carbide.svc.cluster.local/v2/org/{org}/carbide/ipblock
Content-Type: application/json

Create an IP block for the org.

Only Infrastructure Providers can create a root IP Block. User must have `FORGE_PROVIDER_ADMIN` role.

Tenant IP Blocks are created via Allocation.

Reference: https://docs.nvidia.com/infra-controller/infra-controller/rest-api-reference/api-reference/ip-block/create-ipblock

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: NCX Infra Controller REST API
  version: 1.0.0
paths:
  /v2/org/{org}/carbide/ipblock:
    post:
      operationId: create-ipblock
      summary: Create IP Block
      description: >-
        Create an IP block for the org.


        Only Infrastructure Providers can create a root IP Block. User must have
        `FORGE_PROVIDER_ADMIN` role.


        Tenant IP Blocks are created via Allocation.
      tags:
        - subpackage_ipBlock
      parameters:
        - name: org
          in: path
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: >-
            ```

            export JWT_BEARER_TOKEN="<jwt-bearer-token>"


            # Example org name: "acme-inc

            export ORG_NAME=<org-name>


            # Use the JWT bearer token in your API request auth header:

            curl -v -X GET -H "Content-Type: application/json" -H
            "Authorization: Bearer $JWT_BEARER_TOKEN"
            https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

            ```
          required: true
          schema:
            type: string
      responses:
        '201':
          description: Created
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/IpBlock'
        '400':
          description: Error response when request data cannot be validated
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
        '403':
          description: >-
            Error response when user is not authorized to call an endpoint or
            retrieve/modify objects
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/IpBlockCreateRequest'
servers:
  - url: https://carbide-rest-api.carbide.svc.cluster.local
components:
  schemas:
    IpBlockCreateRequestRoutingType:
      type: string
      enum:
        - Public
        - DatacenterOnly
      title: IpBlockCreateRequestRoutingType
    IpBlockCreateRequestProtocolVersion:
      type: string
      enum:
        - IPv4
        - IPv6
      title: IpBlockCreateRequestProtocolVersion
    IpBlockCreateRequest:
      type: object
      properties:
        name:
          type: string
        description:
          type: string
        siteId:
          type: string
          format: uuid
        routingType:
          $ref: '#/components/schemas/IpBlockCreateRequestRoutingType'
        prefix:
          type: string
          description: Either IPv4 or IPv6 address
        prefixLength:
          type: integer
          description: 'Min: 1, Max: 32 for IPv4, 128 for IPv6'
        protocolVersion:
          $ref: '#/components/schemas/IpBlockCreateRequestProtocolVersion'
      required:
        - name
        - siteId
        - routingType
        - prefix
        - prefixLength
        - protocolVersion
      description: Request data for creating IP block
      title: IpBlockCreateRequest
    IpBlockRoutingType:
      type: string
      enum:
        - Public
        - DatacenterOnly
      title: IpBlockRoutingType
    IpBlockProtocolVersion:
      type: string
      enum:
        - IPv4
        - IPv6
      title: IpBlockProtocolVersion
    IpBlockUsageStats:
      type: object
      properties:
        availableIPs:
          type: integer
          format: int64
          description: Number of IP addresses available in the block
        acquiredIPs:
          type: integer
          format: int64
          description: Number of individual IP addresses acquired from the block
        availablePrefixes:
          type: array
          items:
            type: string
          description: Example prefixes available to acquire
        availableSmallestPrefixes:
          type: integer
          format: int64
          description: Number of smallest prefixes available to acquire
        acquiredPrefixes:
          type: integer
          format: int64
          description: Number of prefixes acquired from this block
      description: Usa statistics for an IP Block
      title: IpBlockUsageStats
    IpBlockStatus:
      type: string
      enum:
        - Pending
        - Provisioning
        - Ready
        - Deleting
        - Error
      description: Status values for IP Block objects
      title: IpBlockStatus
    StatusDetail:
      type: object
      properties:
        status:
          type: string
        message:
          type: string
        created:
          type: string
          format: date-time
        updated:
          type: string
          format: date-time
      description: Describes the details of a status transition for a resource
      title: StatusDetail
    Deprecation:
      type: object
      properties:
        attribute:
          type:
            - string
            - 'null'
        queryParam:
          type:
            - string
            - 'null'
        endpoint:
          type:
            - string
            - 'null'
        replacedBy:
          type:
            - string
            - 'null'
        takeActionBy:
          type: string
          format: date-time
        notice:
          type: string
      description: Details of a particular deprecation in NCX Infra Controller API
      title: Deprecation
    IpBlock:
      type: object
      properties:
        id:
          type: string
          format: uuid
        name:
          type: string
        description:
          type: string
        siteId:
          type: string
          format: uuid
        infrastructureProviderId:
          type: string
          format: uuid
        tenantId:
          type:
            - string
            - 'null'
          format: uuid
        routingType:
          $ref: '#/components/schemas/IpBlockRoutingType'
        prefix:
          type: string
          description: Either IPv4 or IPv6 address
        prefixLength:
          type: integer
          description: 'Min: 1, Max: 32 for ipv4, 128 for ipv6'
        protocolVersion:
          $ref: '#/components/schemas/IpBlockProtocolVersion'
        usageStats:
          $ref: '#/components/schemas/IpBlockUsageStats'
        status:
          $ref: '#/components/schemas/IpBlockStatus'
        statusHistory:
          type: array
          items:
            $ref: '#/components/schemas/StatusDetail'
        deprecations:
          type: array
          items:
            $ref: '#/components/schemas/Deprecation'
        created:
          type: string
          format: date-time
        updated:
          type: string
          format: date-time
      description: >-
        IP block contains information about an IPv4 address pool owned by the
        Infrastructure Provider and assigned as an overlay network for a
        particular Site. It is equivalent to Network Resource in product
        terminology.
      title: IpBlock
    CarbideApiErrorSource:
      type: string
      enum:
        - carbide
      description: Source of the error. Only 'carbide' is supported
      title: CarbideApiErrorSource
    CarbideApiErrorData:
      type: object
      properties: {}
      description: Additional data about the error
      title: CarbideApiErrorData
    CarbideAPIError:
      type: object
      properties:
        source:
          $ref: '#/components/schemas/CarbideApiErrorSource'
          description: Source of the error. Only 'carbide' is supported
        message:
          type: string
          description: Message describing the error
        data:
          oneOf:
            - $ref: '#/components/schemas/CarbideApiErrorData'
            - type: 'null'
          description: Additional data about the error
      description: Describes the error response from NCX Infra Controller REST API
      title: CarbideAPIError
  securitySchemes:
    JWTBearerToken:
      type: http
      scheme: bearer
      description: >-
        ```

        export JWT_BEARER_TOKEN="<jwt-bearer-token>"


        # Example org name: "acme-inc

        export ORG_NAME=<org-name>


        # Use the JWT bearer token in your API request auth header:

        curl -v -X GET -H "Content-Type: application/json" -H "Authorization:
        Bearer $JWT_BEARER_TOKEN"
        https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

        ```

```

## SDK Code Examples

```python example-1
import requests

url = "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/ipblock"

payload = {
    "name": "Public Network Overlay for Site SJC4",
    "siteId": "60189e9c-7d12-438c-b9ca-6998d9c364b1",
    "routingType": "Public",
    "prefix": "202.168.1.0",
    "prefixLength": 24,
    "protocolVersion": "IPv4",
    "description": "This is the primary IP overlay for SJC4. All IPs are publicly routable"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript example-1
const url = 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/ipblock';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"name":"Public Network Overlay for Site SJC4","siteId":"60189e9c-7d12-438c-b9ca-6998d9c364b1","routingType":"Public","prefix":"202.168.1.0","prefixLength":24,"protocolVersion":"IPv4","description":"This is the primary IP overlay for SJC4. All IPs are publicly routable"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go example-1
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/ipblock"

	payload := strings.NewReader("{\n  \"name\": \"Public Network Overlay for Site SJC4\",\n  \"siteId\": \"60189e9c-7d12-438c-b9ca-6998d9c364b1\",\n  \"routingType\": \"Public\",\n  \"prefix\": \"202.168.1.0\",\n  \"prefixLength\": 24,\n  \"protocolVersion\": \"IPv4\",\n  \"description\": \"This is the primary IP overlay for SJC4. All IPs are publicly routable\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby example-1
require 'uri'
require 'net/http'

url = URI("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/ipblock")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"Public Network Overlay for Site SJC4\",\n  \"siteId\": \"60189e9c-7d12-438c-b9ca-6998d9c364b1\",\n  \"routingType\": \"Public\",\n  \"prefix\": \"202.168.1.0\",\n  \"prefixLength\": 24,\n  \"protocolVersion\": \"IPv4\",\n  \"description\": \"This is the primary IP overlay for SJC4. All IPs are publicly routable\"\n}"

response = http.request(request)
puts response.read_body
```

```java example-1
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/ipblock")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"Public Network Overlay for Site SJC4\",\n  \"siteId\": \"60189e9c-7d12-438c-b9ca-6998d9c364b1\",\n  \"routingType\": \"Public\",\n  \"prefix\": \"202.168.1.0\",\n  \"prefixLength\": 24,\n  \"protocolVersion\": \"IPv4\",\n  \"description\": \"This is the primary IP overlay for SJC4. All IPs are publicly routable\"\n}")
  .asString();
```

```php example-1
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/ipblock', [
  'body' => '{
  "name": "Public Network Overlay for Site SJC4",
  "siteId": "60189e9c-7d12-438c-b9ca-6998d9c364b1",
  "routingType": "Public",
  "prefix": "202.168.1.0",
  "prefixLength": 24,
  "protocolVersion": "IPv4",
  "description": "This is the primary IP overlay for SJC4. All IPs are publicly routable"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp example-1
using RestSharp;

var client = new RestClient("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/ipblock");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"Public Network Overlay for Site SJC4\",\n  \"siteId\": \"60189e9c-7d12-438c-b9ca-6998d9c364b1\",\n  \"routingType\": \"Public\",\n  \"prefix\": \"202.168.1.0\",\n  \"prefixLength\": 24,\n  \"protocolVersion\": \"IPv4\",\n  \"description\": \"This is the primary IP overlay for SJC4. All IPs are publicly routable\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift example-1
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "name": "Public Network Overlay for Site SJC4",
  "siteId": "60189e9c-7d12-438c-b9ca-6998d9c364b1",
  "routingType": "Public",
  "prefix": "202.168.1.0",
  "prefixLength": 24,
  "protocolVersion": "IPv4",
  "description": "This is the primary IP overlay for SJC4. All IPs are publicly routable"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/ipblock")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```